\let\mypdfximage\pdfximage\def\pdfximage{\immediate\mypdfximage}\documentclass[twoside]{book}

% Packages required by doxygen
\usepackage{fixltx2e}
\usepackage{calc}
\usepackage{doxygen}
\usepackage{graphicx}
\usepackage[utf8]{inputenc}
\usepackage{makeidx}
\usepackage{multicol}
\usepackage{multirow}
\PassOptionsToPackage{warn}{textcomp}
\usepackage{textcomp}
\usepackage[nointegrals]{wasysym}
\usepackage[table]{xcolor}
\usepackage{ifpdf,ifxetex}

% Font selection
\usepackage[T1]{fontenc}
\usepackage[scaled=.90]{helvet}
\usepackage{courier}
\usepackage{amssymb}
\usepackage{sectsty}
\renewcommand{\familydefault}{\sfdefault}
\allsectionsfont{%
  \fontseries{bc}\selectfont%
  \color{darkgray}%
}
\renewcommand{\DoxyLabelFont}{%
  \fontseries{bc}\selectfont%
  \color{darkgray}%
}
\newcommand{\+}{\discretionary{\mbox{\scriptsize$\hookleftarrow$}}{}{}}

% Arguments of doxygenemoji:
% 1) ':<text>:' form of the emoji, already "LaTeX"-escaped
% 2) file with the name of the emoji without the .png extension
% in case image exist use this otherwise use the ':<text>:' form
\newcommand{\doxygenemoji}[2]{%
  \IfFileExists{./#2.png}{\raisebox{-0.1em}{\includegraphics[height=0.9em]{./#2.png}}}{#1}%
}
% Page & text layout
\usepackage{geometry}
\geometry{%
  a4paper,%
  top=2.5cm,%
  bottom=2.5cm,%
  left=2.5cm,%
  right=2.5cm%
}
\tolerance=750
\hfuzz=15pt
\hbadness=750
\setlength{\emergencystretch}{15pt}
\setlength{\parindent}{0cm}
\newcommand{\doxynormalparskip}{\setlength{\parskip}{3ex plus 2ex minus 2ex}}
\newcommand{\doxytocparskip}{\setlength{\parskip}{1ex plus 0ex minus 0ex}}
\doxynormalparskip
\makeatletter
\renewcommand{\paragraph}{%
  \@startsection{paragraph}{4}{0ex}{-1.0ex}{1.0ex}{%
    \normalfont\normalsize\bfseries\SS@parafont%
  }%
}
\renewcommand{\subparagraph}{%
  \@startsection{subparagraph}{5}{0ex}{-1.0ex}{1.0ex}{%
    \normalfont\normalsize\bfseries\SS@subparafont%
  }%
}
\makeatother

% Headers & footers
\usepackage{fancyhdr}
\pagestyle{fancyplain}
\fancyhead[LE]{\fancyplain{}{\bfseries\thepage}}
\fancyhead[CE]{\fancyplain{}{}}
\fancyhead[RE]{\fancyplain{}{\bfseries\leftmark}}
\fancyhead[LO]{\fancyplain{}{\bfseries\rightmark}}
\fancyhead[CO]{\fancyplain{}{}}
\fancyhead[RO]{\fancyplain{}{\bfseries\thepage}}
\fancyfoot[LE]{\fancyplain{}{}}
\fancyfoot[CE]{\fancyplain{}{}}
\fancyfoot[RE]{\fancyplain{}{\bfseries\scriptsize Generated by Doxygen }}
\fancyfoot[LO]{\fancyplain{}{\bfseries\scriptsize Generated by Doxygen }}
\fancyfoot[CO]{\fancyplain{}{}}
\fancyfoot[RO]{\fancyplain{}{}}
\renewcommand{\footrulewidth}{0.4pt}
\renewcommand{\chaptermark}[1]{%
  \markboth{#1}{}%
}
\renewcommand{\sectionmark}[1]{%
  \markright{\thesection\ #1}%
}

% Indices & bibliography
\usepackage{natbib}
\usepackage[titles]{tocloft}
\setcounter{tocdepth}{3}
\setcounter{secnumdepth}{5}
\makeindex

\usepackage{newunicodechar}
  \newunicodechar{⁻}{${}^{-}$}% Superscript minus
  \newunicodechar{²}{${}^{2}$}% Superscript two
  \newunicodechar{³}{${}^{3}$}% Superscript three

% Hyperlinks (required, but should be loaded last)
\ifpdf
  \usepackage[pdftex,pagebackref=true]{hyperref}
\else
  \ifxetex
    \usepackage[pagebackref=true]{hyperref}
  \else
    \usepackage[ps2pdf,pagebackref=true]{hyperref}
  \fi
\fi

\hypersetup{%
  colorlinks=true,%
  linkcolor=blue,%
  citecolor=blue,%
  unicode%
}

% Custom commands
\newcommand{\clearemptydoublepage}{%
  \newpage{\pagestyle{empty}\cleardoublepage}%
}

\usepackage{caption}
\captionsetup{labelsep=space,justification=centering,font={bf},singlelinecheck=off,skip=4pt,position=top}

\usepackage{etoc}
\etocsettocstyle{\doxytocparskip}{\doxynormalparskip}
\renewcommand{\numberline}[1]{#1~}
%===== C O N T E N T S =====

\begin{document}

% Titlepage & ToC
\hypersetup{pageanchor=false,
             bookmarksnumbered=true,
             pdfencoding=unicode
            }
\pagenumbering{alph}
\begin{titlepage}
\vspace*{7cm}
\begin{center}%
{\Large My Project }\\
\vspace*{1cm}
{\large Generated by Doxygen 1.8.15}\\
\end{center}
\end{titlepage}
\clearemptydoublepage
\pagenumbering{roman}
\tableofcontents
\clearemptydoublepage
\pagenumbering{arabic}
\hypersetup{pageanchor=true}

%--- Begin generated contents ---
\chapter{E\+S\+P32 C++ Utility Classes}
\label{index}\hypertarget{index}{}\input{index}
\chapter{Arduino B\+LE Support}
\label{md_ArduinoBLE}
\Hypertarget{md_ArduinoBLE}
\input{md_ArduinoBLE}
\chapter{C\+PP Utils}
\label{md_README}
\Hypertarget{md_README}
\input{md_README}
\chapter{Hierarchical Index}
\input{hierarchy}
\chapter{Class Index}
\input{annotated}
\chapter{Class Documentation}
\input{structaddressRange__t}
\input{classApa102}
\input{classArgTable}
\input{classArgTableEntry__Date}
\input{classArgTableEntry__Double}
\input{classArgTableEntry__File}
\input{classArgTableEntry__Generic}
\input{classArgTableEntry__Int}
\input{classArgTableEntry__Lit}
\input{classArgTableEntry__Regex}
\input{classArgTableEntry__String}
\input{classBLEBeacon}
\input{classBLEDisconnectedException}
\input{classBLEEddystoneTLM}
\input{classBLEEddystoneURL}
\input{classBLEUuidNotFoundException}
\input{structcamera__config__t}
\input{classConsole}
\input{structdata__packet}
\input{structdma__config__t}
\input{classDMABuffer}
\input{classDMAData}
\input{classFATFS__VFS}
\input{classFile}
\input{classFTPServer_1_1FileException}
\input{classFileSystem}
\input{structFrame}
\input{classFreeRTOS}
\input{classFreeRTOSTimer}
\input{classFTPCallbacks}
\input{classFTPFileCallbacks}
\input{classFTPServer}
\input{classGeneralUtils}
\input{classESP32CPP_1_1GPIO}
\input{structHID__REPORT}
\input{classHttpParser}
\input{classHttpRequest}
\input{classHttpResponse}
\input{classHttpServer}
\input{classHttpServerTask}
\input{classI2C}
\input{classSOC_1_1I2S}
\input{classI2S}
\input{classIFTTT}
\input{structio__mux__dev__t}
\input{structio__mux__reg__t}
\input{classJSON}
\input{classJsonArray}
\input{classJsonObject}
\input{structKEYMAP}
\input{classMAX7219}
\input{classMFRC522}
\input{classMFRC522Debug}
\input{structMFRC522_1_1MIFARE__Key}
\input{classMMU}
\input{classMPU6050}
\input{structmqtt__InitTypeDef}
\input{structmqtt__message}
\input{classNeoPixelWiFiEventHandler}
\input{classNVS}
\input{classOV7670}
\input{classPathHandler}
\input{classPCF8574}
\input{classPCF8575}
\input{structpixel__t}
\input{classPubSubClient}
\input{classPubSubClientTask}
\input{classPWM}
\input{classRingbuffer}
\input{classRMT}
\input{classFreeRTOS_1_1Semaphore}
\input{classSmartLED}
\input{classSOC}
\input{classSocket}
\input{classSocketException}
\input{classSocketInputRecordStreambuf}
\input{classSockServ}
\input{classSPI}
\input{classSSLUtils}
\input{classSystem}
\input{classTask}
\input{classTFTP}
\input{classTFTP_1_1TFTP__Transaction}
\input{structMFRC522_1_1Uid}
\input{classWebSocket}
\input{classWebSocketFileTransfer}
\input{classWebSocketHandler}
\input{classWebSocketInputStreambuf}
\input{classWebSocketReader}
\input{classWiFi}
\input{classWiFiAPRecord}
\input{classWiFiEventHandler}
\input{classWS2812}
%--- End generated contents ---

% Index
\backmatter
\newpage
\phantomsection
\clearemptydoublepage
\addcontentsline{toc}{chapter}{\indexname}
\printindex

\end{document}
